#!/usr/bin/env ruby
# -*- coding: utf-8 -*-

=begin
	Link_Creator.rb ver 0.0.1
	lnコマンドを利用して、シンボリックリンク？だかいうのを作るツール（たぶん）
=end
require 'gtk2'

#Gladeファイル読み込み
builder = Gtk::Builder.new
builder.add_from_file("Link_Creator.glade")

$dialog_mode = ""

#ーーーーー　メインウィンドウ系　ーーーーー
@window = builder["window1"]
@ent_org = builder["entry_org"]
@ent_lnk = builder["entry_link"]
@buf_log = builder["textbuffer1"]
@view_log = builder["textview1"]

@btn_quit = builder["btn_quit"]
@btn_org = builder["btn_org"]
@btn_lnk = builder["btn_link"]
@btn_mk = builder["btn_make"]

#ーーーーー　ファイル選択ダイアログ系　ーーーーー
@dialog_f_select = builder["filechooserdialog1"]
@btn_ok = builder["btn_ok"]
@btn_cancel = builder["btn_cancel"]

#ーーーーー　メインウィンドウ終了系　ーーーーー
@window.signal_connect("delete-event") do
	false	#下のdestroyイベントにお渡し（ここにGtk.main_quitを書いて終了させても良いのかもしれないけど…）
end
@window.signal_connect("destroy") do
	Gtk.main_quit
end

#ーーーーー　終了ボタンが押されたら　ーーーーー
@btn_quit.signal_connect("clicked") do
	Gtk.main_quit
end

#オリジナル選択
@btn_org.signal_connect("clicked") do
	$dialog_mode = "org"
	open_dialog()
end

#作成先を選択
@btn_lnk.signal_connect("clicked") do
	$dialog_mode = "link"
	open_dialog()
end

#ダイアログを開くYO
def open_dialog()
	if $dialog_mode == "org" then
		@dialog_f_select.title = "３分間待ってやる。作成元ファイル・ディレクトリを選びたまえ"
		@dialog_f_select.select_multiple = false
		@dialog_f_select.action = "open"
	else
		@dialog_f_select.title = "５分間待ってやる。作成先ディレクトリを選びたまえ"
		@dialog_f_select.select_multiple = false
		@dialog_f_select.action = "select-folder"
	end
	@dialog_f_select.show
end

#ーーーーー　作成ボタンが押されたらん　ーーーーー
@btn_mk.signal_connect("clicked") do
	if @ent_org.text != "" and @ent_lnk.text != "" then
		if File.exists?(@ent_lnk.text) == true then
			view_txt("＊＊＊＊＊　そ、そこにナニかいるぅ〜　＊＊＊＊＊＊")
		else
			ln_cmd = "ln -s -v '#{@ent_org.text}' '#{@ent_lnk.text}'"
			r = `#{ln_cmd}`
			view_txt(r.chomp)
			view_txt("ーーーーー　処理完了　ーーーーー")
		end
	else
		view_txt("＊＊＊＊＊　作成元、作成先を指定してやぁ　＊＊＊＊＊")
	end
end


#ファイル選択ダイアログのOKボタンが押された
@btn_ok.signal_connect("clicked") do
	sel_f = @dialog_f_select.filename
	if $dialog_mode == "org" then
		@ent_org.text = sel_f
	else
		if @ent_org.text != "" then
			ln_name = "/#{File::basename(@ent_org.text)}"
		else
			ln_name = "/dummy"
		end
		@ent_lnk.text = "#{sel_f}#{ln_name}"
	end
	@dialog_f_select.hide
end

#ファイル選択ダイアログのクローズ
@btn_cancel.signal_connect("clicked") do
	@dialog_f_select.hide
end

#ファイル選択ダイアログがescキーなどで不意に破棄されるのを防止
@dialog_f_select.signal_connect("delete_event") do
	@dialog_f_select.hide
	true
end

def view_txt(t)
	if t == "" then
		@buf_log.text = ""
	else
		@buf_log.text += "#{t}\n"
	end
	@view_log.move_cursor(Gtk::MOVEMENT_PAGES, 1, false)	#一番最後のページにスクロールを移動
end

#ーーーーー　メインウィンドウの表示　ーーーーー
@window.show_all

Gtk.main
#お疲れ様でした

